#include "client.h"

int main(int argv,char* argc[]) {
  if(argv < 2) {
    cerr<<"Missing url"<<endl;
    exit(1);
  };
  if(globus_module_activate(GLOBUS_IO_MODULE) != GLOBUS_SUCCESS) {
    cerr<<"Failed to activate IO"<<endl;
    exit(1);
  };
  HTTP_Client client(argc[1]);
  if(!client) {
    cerr<<"Failed to create client for "<<argc[1]<<endl;
    exit(1);
  };
  if(client.connect() != 0) {
    cerr<<"Failed to connect to "<<argc[1]<<endl;
    return false;
  };
  client.disconnect();
  cerr<<"Passed"<<endl;
  exit(0);
};
