/*
 * Created on Nov 7, 2005
 *
 * TODO Implement it, then write some documentation
 *
 */
package se.umu.jobsubmission.util;

import org.globus.mds.glue.ApplicationSoftwareType;
import org.globus.mds.glue.ArchitectureType;
import org.globus.mds.glue.ClusterType;
import org.globus.mds.glue.ComputingElementType;
import org.globus.mds.glue.FileSystemType;
import org.globus.mds.glue.GLUECERPType;
import org.globus.mds.glue.InfoType;
import org.globus.mds.glue.MainMemoryType;
import org.globus.mds.glue.OperatingSystemType;
import org.globus.mds.glue.PolicyType;
import org.globus.mds.glue.StateType;
import org.globus.mds.glue.HostType;
import org.globus.mds.glue.SubClusterType;
import org.globus.mds.glue.BenchmarkType;

/**
 * @author tordsson
 *
 * TODO Add a proper description of this class. 
 */
public class GLUEUtils {

	// The only use of this constant is to avoid job not being submitted 
	// to a cluster that advertises maxrunningjobs = 0
	public static int DEFAULT_MAX_RUNNING_JOBS = 131072; 
	
	// Default value for maxtotaljobs (only used when clusters) does 
	// not advertises a value. 
	public static int DEFAULT_MAX_TOTAL_JOBS = 262144; 
	
	 // Create a complete GLUECERP object, with all subobjects (that we use...)
    public static GLUECERPType createGLUECERP() {

        GLUECERPType GLUECERP = new GLUECERPType(); 

        // Cluster part
        
        // Can ARCResource hold >1 queue? In that case, this is too small...
        ClusterType clusters[] = new ClusterType[1]; 
        clusters[0] = new ClusterType(); 

        GLUECERP.setCluster(clusters); 

        SubClusterType subClusters[] = new SubClusterType[1]; 
        subClusters[0] = new SubClusterType(); 
        clusters[0].setSubCluster(subClusters); 
        HostType hosts[] = new HostType[] {new HostType()}; 
        subClusters[0].setHost(hosts); 

        ArchitectureType architecture = new ArchitectureType(); 
        hosts[0].setArchitecture(architecture); 
        OperatingSystemType operatingSystem = new OperatingSystemType(); 
        hosts[0].setOperatingSystem(operatingSystem); 
        ApplicationSoftwareType appSoftware = new ApplicationSoftwareType(); 
        hosts[0].setApplicationSoftware(appSoftware); 
        FileSystemType fileSystems[] = new FileSystemType[1]; 
        fileSystems[0] = new FileSystemType(); 
        hosts[0].setFileSystem(fileSystems); 
        MainMemoryType mainMemory = new MainMemoryType(); 
        hosts[0].setMainMemory(mainMemory); 
        BenchmarkType benchmarks = new BenchmarkType(); 
        hosts[0].setBenchmark(benchmarks); 

    
        // ComputingElement part
        ComputingElementType computingElements[] = new ComputingElementType[1]; 
        computingElements[0] = new ComputingElementType(); 

        GLUECERP.setComputingElement(computingElements); 

        InfoType info = new InfoType(); 
        computingElements[0].setInfo(info); 
        StateType state = new StateType(); 
        computingElements[0].setState(state); 
        PolicyType policy = new PolicyType(); 
        computingElements[0].setPolicy(policy); 

        return GLUECERP; 

    }
}
