#include "../client/client.h"
#include <stdsoap2.h>
 
#include "service.h"

/// Interface to remote service
class FlOClient: public HTTP_ClientSOAP {
 private:
  struct soap soap;
 public:
  FlOClient(pFlOServiceRemote s);
  FlOClient(FlOServiceRemote& s);
  ~FlOClient(void);
  /// Register at remote service
  bool registr(FlOService& s);
  /// Send notification to remote service
  bool notify(std::list<FlOMessage>& msgs);
};

