/*
 * Created on Oct 10, 2005
 */
package se.umu.jobsubmission.impl.informationfinder;

import java.util.LinkedList;
import java.util.List;

import javax.naming.NamingException;

import org.apache.log4j.Logger;

/**
 * @author tordsson
 *
 * Only used for testing that chain-of-responsibility works ok for 
 * InformationFetcher classes. 
 *
 */
public class WrongInformationFetcher implements InformationFetcher {

	private static Logger logger = Logger.getLogger(WrongInformationFetcher.class); 
    
    public String translateURL(String URL) {
    	
    	if(URL.startsWith("ldap://"))
    		return URL; 
    	else
    		return "ldap://" + URL + ":2135/nordugrid-cluster-name=" + URL 
			+ ",Mds-Vo-name=local,o=grid"; 
    }
    
    public Object getInformation(String resourceURL, int timeout) 
    	throws Exception {
    	logger.error("Not implemented, only for error testing"); 
    	throw new Exception("Not implemented, only for error testing"); 
    
    }
}